package builders;

import com.vividsolutions.jts.geom.Coordinate;
import com.vividsolutions.jts.geom.GeometryFactory;
import com.vividsolutions.jts.geom.Point;
import deserializers.GeometryDeserializer;
import models.Localizacao;
import play.Play;

public class LocalizacaoBuilder extends BaseModelBuilder<Localizacao> {

	public static final Integer SRID = Integer.valueOf(Play.configuration.getProperty("application.geo.srid"));
	public static final GeometryFactory factory = new GeometryFactory();


	public LocalizacaoBuilder() {

		super(new Localizacao());
		padrao();

	}

	@Override
	protected LocalizacaoBuilder padrao() {

		Point ponto = factory.createPoint(new Coordinate(0,0,0));
		ponto.setSRID(SRID);

		this.model.geometria = ponto;

		return this;

	}

	public LocalizacaoBuilder semGeometria() {

		this.model.geometria = null;

		return this;

	}

	public LocalizacaoBuilder comMaisDeUmPoligono() {

		String stringJsonGeometria = "{\"geometry\":{\"type\":\"Polygon\",\"coordinates\":[[[-45.54481565952301,-23.014173384404337],[-45.54479420185089,-23.014079572742332],[-45.544955134391785,-23.01400551085782],[-45.54489612579346,-23.01383269963583],[-45.544670820236206,-23.013941323858358],[-45.544225573539734,-23.01298345269899],[-45.54557204246521,-23.012371201590646],[-45.54610311985016,-23.0135858260775],[-45.54481565952301,-23.014173384404337]],[[-45.54523944854736,-23.006337417051466],[-45.54687023162842,-23.007996487814975],[-45.546913146972656,-23.00839150165672],[-45.54688364267349,-23.008460628960133],[-45.54681122303009,-23.008554444529526],[-45.54677098989487,-23.00861616526332],[-45.54674685001373,-23.008638384720545],[-45.54671466350555,-23.008687761279113],[-45.54662346839904,-23.008742075472647],[-45.5464705824852,-23.008816140246793],[-45.54623991250992,-23.008895142627726],[-45.54615676403046,-23.00889020498027],[-45.546046793460846,-23.008853172618615],[-45.545958280563354,-23.0087544196045],[-45.54588049650192,-23.008707511897473],[-45.54577052593231,-23.008675417141166],[-45.54561495780945,-23.00871244955161],[-45.545464754104614,-23.008786514342017],[-45.54536819458008,-23.008786514342017],[-45.545196533203125,-23.008747013125525],[-45.54508924484253,-23.00861863409206],[-45.54503560066223,-23.0085198809063],[-45.54500341415405,-23.00799155013464],[-45.54501950740814,-23.00719658124348],[-45.54503560066223,-23.006776875281403],[-45.54508924484253,-23.006381856712807],[-45.54512679576874,-23.00630285286031],[-45.54523944854736,-23.006337417051466]]]}}";

		this.model.geometria = GeometryDeserializer.parseGeometry(stringJsonGeometria);

		return this;

	}

}
